#!/bin/sh -e
if [ $# -lt 1 ]; then
    echo "usage: $0 /path/to/cygwin/build" 1>&2
    exit 1;
fi

cvt() {
    sed -e '/<?xml version/d' -e 's/&copy;/(C)/' -e 's/&reg;/(R)/' "$1" > "$2"/$(basename "$1")
}

builddir="$1"

if [ ! -d "$builddir/winsup/doc" ]; then
    echo "usage: $0 /path/to/cygwin/build" 1>&2
    echo "(Don't include winsup)" 1>&2
    exit 1;
fi

eval $(grep '^srcdir=' "$builddir/newlib/config.status" 2>/dev/null)

if [ -z "$srcdir" ]; then
    echo "couldn't find srcdir in \"$builddir/newlib/config.status\"" 1>&2
    exit 1
fi

srcdir=$(cd "$srcdir"/..; pwd)
if [ -z "$srcdir" ]; then
    echo "couldn't find srcdir path from $srcdir/.." 1>&2
    exit 1
fi

rm -rf src
mkdir -p src/api src/utils src/info
for f in "$builddir/winsup"/doc/*.sgml "$srcdir"/winsup/cygwin/*.sgml; do
    cvt "$f" src/api
done
for f in "$srcdir/winsup"/utils/*.sgml; do
    cvt "$f" src/utils
done

for i in libc libm; do
    if [ -f "$srcdir/newlib/$i/$i.info" ]; then
	f="$srcdir/newlib/$i/$i.info"
    elif [ -f "$builddir/newlib/$i/$i.info" ]; then
	f="$builddir/newlib/$i/$i.info"
    else
	echo "New $builddir/newlib/$i/$i.info file not found!" 1>&2
	exit 1
    fi 
    cat ${f}* > src/info/$i.info
done

exec cp -p "$srcdir"/winsup/doc/*.dsl src/
